#define DEBUG 0
#include <Debug.h>

#include <stdlib.h>
#include <string.h>

#include <String.h>
#include <Roster.h>
#include <Alert.h>

#include "BeShareOpenerApp.h"

const char * beshare_appsig	=	"application/x-vnd.Sugoi-BeShare";

BeShareOpenerApp::BeShareOpenerApp	()
 :	BApplication	("application/x-vnd.kirilla-beshareopener"),
 	m_got_the_url			(false)
{
	// void
}

BeShareOpenerApp::~BeShareOpenerApp	(void)	
{
	// void
}

void 
BeShareOpenerApp::ArgvReceived	(int32 argc, char **argv)
{
	if(argc <= 1)	// no arguments
		return;
	
	if(argc > 2)	// too many arguments
		return;

	BString server	=	argv[1];
	BString query	=	argv[1];
	
	if (server.IFindFirst("beshare://") != 0)
		return;
	
	m_got_the_url	=	true;
	
	server.IReplaceAll("beshare://", "");
	query.IReplaceAll("beshare://", "");
	
	int32	divider	=	query.FindFirst("/");

	if ((divider >= 0) && (divider < server.Length()))
	{
		server.Truncate (divider);
		query.Remove (0, divider + 1);
	}
	else
		query.Truncate(0);
	
	if (! be_roster->IsRunning(beshare_appsig))
		be_roster->Launch(beshare_appsig);
		
	for (int trial = 1;	trial < 20;	trial++)
	{
		if (be_roster->IsRunning(beshare_appsig))
			break;

		printf("BeShare launching...\n");
		snooze(200000);
	}

	snooze(1000000);

	if (be_roster->IsRunning(beshare_appsig))
	{	
		BMessenger	beshare		(beshare_appsig);
		BMessage	server_msg	('serv');
		BMessage	query_msg	('quer');
		
		server_msg.AddString("server", server);
		query_msg.AddString("query", query);

		beshare.SendMessage(& server_msg);
		beshare.SendMessage(& query_msg);
	}
	else
	{
		(new BAlert("BeShareOpener - Error\n", "BeShareOpener couldn't open BeShare.", 
		"Swell", NULL, NULL, B_WIDTH_AS_USUAL, B_STOP_ALERT))->Go(); 
	}
}

void
BeShareOpenerApp::ReadyToRun	(void)
{
	if (! m_got_the_url)
	{
		(new BAlert("BeShareOpener - Error\n", "BeShareOpener needs "
		"a single argument of this format: beshare://server/query to do anything useful.", 
		"I see", NULL, NULL, B_WIDTH_AS_USUAL, B_STOP_ALERT))->Go();
	}	

	PostMessage(B_QUIT_REQUESTED);
}

